<?php

//////////
///
///   err.inc.php
///
//////////



$errno = array('auth'     =>  1100,
               'user'     =>  1200,
               'group'    =>  1300,
               'activity' =>  1400,
               'target'   =>  1600,
               'backdoor' =>  1700,
               'member'   =>  1800,
               'assign'   =>  1900,
               'config'   =>  2000,
               'upload'   =>  2100,
               'download' =>  2200,
               'note'     =>  2300,
               'blotter'  =>  2400,
               'session'  =>  2500,
               'limit'    =>  2600,
               'db'       => 10000);

$err = array('auth'     => array('failed'              => array('faultCode' => $errno['auth']     + 1, 'faultString' => 'Authentication failed')),
             'user'     => array('exists'              => array('faultCode' => $errno['user']     + 1, 'faultString' => 'User already exists'),
                                 'licenselimit'        => array('faultCode' => $errno['user']     + 2, 'faultString' => 'License limit reached')),
             'group'    => array('exists'              => array('faultCode' => $errno['group']    + 1, 'faultString' => 'Group already exists')),
             'activity' => array('exists'              => array('faultCode' => $errno['activity'] + 1, 'faultString' => 'Activity already exists'),
                                 'nosuchactivity'      => array('faultCode' => $errno['activity'] + 2, 'faultString' => 'No such activity'),
                                 'noperm'              => array('faultCode' => $errno['activity'] + 3, 'faultString' => 'No permission')),
             'target'   => array('exists'              => array('faultCode' => $errno['target']   + 1, 'faultString' => 'Target already exists'),
                                 'nosuchtarget'        => array('faultCode' => $errno['target']   + 2, 'faultString' => 'No such target'),
                                 'nosuchactivity'      => array('faultCode' => $errno['target']   + 3, 'faultString' => 'No such activity'),
                                 'noperm'              => array('faultCode' => $errno['target']   + 4, 'faultString' => 'No permission')),
             'backdoor' => array('exists'              => array('faultCode' => $errno['backdoor'] + 1, 'faultString' => 'Backdoor already exists'),
                                 'nosuchbackdoor'      => array('faultCode' => $errno['backdoor'] + 2, 'faultString' => 'No such backdoor'),
                                 'nosuchtarget'        => array('faultCode' => $errno['backdoor'] + 3, 'faultString' => 'No such target'),
                                 'noperm'              => array('faultCode' => $errno['backdoor'] + 4, 'faultString' => 'No permission'),
                                 'licenselimit'        => array('faultCode' => $errno['backdoor'] + 5, 'faultString' => 'License limit reached')),
             'member'   => array('exists'              => array('faultCode' => $errno['member']   + 1, 'faultString' => 'User already member of group'),
                                 'nosuchgroupuser'     => array('faultCode' => $errno['member']   + 2, 'faultString' => 'Invalid group or user')),
             'assign'   => array('exists'              => array('faultCode' => $errno['assign']   + 1, 'faultString' => 'Group already assigned to activity'),
                                 'nosuchactivitygroup' => array('faultCode' => $errno['assign']   + 2, 'faultString' => 'Invalid activity or group')),
             'config'   => array('nosuchconfig'        => array('faultCode' => $errno['config']   + 1, 'faultString' => 'No such config'),
                                 'nosuchbackdoor'      => array('faultCode' => $errno['config']   + 2, 'faultString' => 'No such backdoor'),
                                 'noperm'              => array('faultCode' => $errno['config']   + 3, 'faultString' => 'No permission')),
             'upload'   => array('nosuchbackdoor'      => array('faultCode' => $errno['upload']   + 1, 'faultString' => 'No such backdoor'),
                                 'noperm'              => array('faultCode' => $errno['upload']   + 2, 'faultString' => 'No permission')),
             'download' => array('nosuchbackdoor'      => array('faultCode' => $errno['download'] + 1, 'faultString' => 'No such backdoor'),
                                 'noperm'              => array('faultCode' => $errno['download'] + 2, 'faultString' => 'No permission')),
             'note'     => array('nosuchnote'          => array('faultCode' => $errno['note']     + 1, 'faultString' => 'No such note'),
                                 'nosuchlog'           => array('faultCode' => $errno['note']     + 2, 'faultString' => 'No such log')),
             'blotter'  => array('exists'              => array('faultCode' => $errno['blotter']  + 1, 'faultString' => 'Blotter already exists'),
                                 'nosuchactivity'      => array('faultCode' => $errno['blotter']  + 2, 'faultString' => 'No such activity'),
                                 'alreadyin'           => array('faultCode' => $errno['blotter']  + 3, 'faultString' => 'Log already in blotter'),
                                 'nosuchblotterlog'    => array('faultCode' => $errno['blotter']  + 4, 'faultString' => 'Invalid blotter or log')),
             'session'  => array('nosuchupload'        => array('faultCode' => $errno['session']  + 1, 'faultString' => 'No such upload'),
                                 'nosuchfile'          => array('faultCode' => $errno['session']  + 2, 'faultString' => 'No such file')),
             'limit'    => array('invalidlicense'      => array('faultCode' => $errno['limit']    + 1, 'faultString' => 'Invalid license')),
             'db'       => array('generic'             => array('faultCode' => $errno['db']       + 1, 'faultString' => 'Generic database error'),
                                 'nosuchtype'          => array('faultCode' => $errno['db']       + 2, 'faultString' => 'No such type')));



define('STATUS_SUCCESS', 0x00);
define('STATUS_ERROR', 0x01);



/***************\
*   FUNCTIONS   *
\***************/

function success($payload)
{
   $ret['status'] = STATUS_SUCCESS;
   $ret['payload'] = $payload;

   return $ret;
}

function error($category, $error, $faultCode = false, $faultString = false)
{
   $ret['status'] = STATUS_ERROR;

   if(($category === false) && ($error === false)) {
      $ret['payload'] = array('faultCode'   => $faultCode,
                              'faultString' => $faultString);
   } else {
      $ret['payload'] = $GLOBALS['err'][$category][$error];
   }

   return $ret;
}

function is_success($response)
{
   return ($response['status'] == STATUS_SUCCESS) ? true : false;
}

?>
