<?php

//////////
///
///   user.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['user.add'] = array('func'   => 'user_add',
                        'perm'   => AL_ADMN,
                        'escape' => true);

$dm['user.mod'] = array('func'   => 'user_mod',
                        'perm'   => AL_ADMN,
                        'escape' => true);

$dm['user.del'] = array('func'   => 'user_del',
                        'perm'   => AL_ADMN,
                        'escape' => true);

$dm['user.get'] = array('func'   => 'user_get',
                        'perm'   => AL_ADMN,
                        'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function user_add($user, $desc, $pass, $levelarray)
{
   $em[1062] = array('user', 'exists');

   $ret = getlimit('user');

   if(!is_success($ret)) {
      return $ret;
   }

   if($ret['payload'] === false) {
      return error('user', 'licenselimit');
   }

   $level = AL_NONE;
   in_array('ADMN', $levelarray) && $level |= AL_ADMN;
   in_array('SERV', $levelarray) && $level |= AL_SERV;
   in_array('TECH', $levelarray) && $level |= AL_TECH;
   in_array('VIEW', $levelarray) && $level |= AL_VIEW;

   $sql  = "INSERT INTO `user` (`user`, ";
   $sql .=                     "`desc`, ";
   $sql .=                     "`pass`, ";
   $sql .=                     "`level`) ";
   $sql .= "VALUES ('$user', ";
   $sql .=         "'$desc', ";
   $sql .=         "SHA1('$pass'), ";
   $sql .=         "'$level')";

   $ret = db_query($sql, $em);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `user_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   trace('user.add', "user=$user({$ret['payload'][0]->user_id}), level=".implode(',', $levelarray), $ret['payload'][0]->user_id, 0, 0, 0, 0);

   return success((integer)$ret['payload'][0]->user_id);
}

function user_mod($user_id, $user, $desc, $pass, $levelarray)
{
   $em[1062] = array('user', 'exists');

   $level = AL_NONE;
   in_array('ADMN', $levelarray) && $level |= AL_ADMN;
   in_array('SERV', $levelarray) && $level |= AL_SERV;
   in_array('TECH', $levelarray) && $level |= AL_TECH;
   in_array('VIEW', $levelarray) && $level |= AL_VIEW;

   trace('user.mod', "user=$user($user_id), level=".implode(',', $levelarray), $user_id, 0, 0, 0, 0);

   $sql  = "UPDATE `user` ";
   $sql .= "SET `user` = '$user', ";
   $sql .=     "`desc` = '$desc', ";
   $sql .= ($pass ? "`pass` = SHA1('$pass'), " : '');
   $sql .=     "`level` = '$level' ";
   $sql .= "WHERE `user_id` = '$user_id'";

   return db_query($sql, $em);
}

function user_del($user_id)
{
   trace('user.del', "user_id=$user_id", $user_id, 0, 0, 0, 0);

   $sql  = "DELETE FROM `user` ";
   $sql .= "WHERE `user_id` = '$user_id'";

   return db_query($sql);
}

function user_get($user_id)
{
   $sql  = "SELECT `user_id`, ";
   $sql .=        "`user`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user`";
   $sql .= ($user_id ? " WHERE `user_id` = '$user_id'" : '');

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   foreach($ret['payload'] as &$r) {
      ($r->level & AL_ADMN) && $r->levelarray[] = 'ADMN';
      ($r->level & AL_SERV) && $r->levelarray[] = 'SERV';
      ($r->level & AL_TECH) && $r->levelarray[] = 'TECH';
      ($r->level & AL_VIEW) && $r->levelarray[] = 'VIEW';
      unset($r->level);
   }
   unset($r);

   return $ret;
}

?>
